Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
%define version 1.0
%define name maven-doxia
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


# If you don't want to build with maven, and use straight ant instead,
# give rpmbuild option '--without maven'

%define with_maven %{!?_without_maven:1}%{?_without_maven:0}
%define without_maven %{?_without_maven:1}%{!?_without_maven:0}

%define bname doxia
%define namedversion 1.0-alpha-10

%define maven_settings_file %{_builddir}/%{name}/settings.xml

Name:           maven-doxia
Version:        1.0
Release:        alt2_0.a10.4jpp5
Epoch:          0
Summary:        Doxia is a content generation framework
License:        Apache Software License
Group:          Development/Java
#Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
#Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
URL:            http://maven.apache.org/doxia/
Source0:        %{bname}-%{namedversion}.tar.gz
# svn export http://svn.apache.org/repos/asf/maven/doxia/doxia/tags/doxia-1.0-alpha-10/
Source1:        %{bname}-sitetools-%{namedversion}.tar.gz
# svn export http://svn.apache.org/repos/asf/maven/doxia/doxia-sitetools/tags/doxia-sitetools-1.0-alpha-10/


Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml

Source4:        %{name}-autogenerated-files.tar.gz

Patch0:         maven-doxia-pom.patch
Patch1:         maven-doxia-sitetools-doc-renderer-pom.patch
Patch2:         maven-doxia-siterenderer-Renderer.patch
Patch3:         maven-doxia-siterenderer-DefaultSiteRenderer.patch



BuildArch:      noarch
BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: ant >= 0:1.6.5
BuildRequires: ant-nodeps
BuildRequires: ant-junit
BuildRequires: junit >= 0:3.8.2
BuildRequires: modello >= 0:1.0-0.a17
%if %{with_maven}
BuildRequires: maven2 >= 0:2.0.4
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-plugin
BuildRequires: maven2-plugin-resources
BuildRequires: maven2-plugin-site
BuildRequires: maven-shared-archiver
BuildRequires: maven-surefire-plugin
BuildRequires: plexus-maven-plugin >= 0:1.3.5
BuildRequires: maven-plugin-modello >= 0:1.0-0.a17
%endif
BuildRequires: cssparser
BuildRequires: excalibur-avalon-framework
BuildRequires: geronimo-jta-1.0.1B-api
BuildRequires: htmlunit
BuildRequires: itext >= 0:1.4
BuildRequires: jakarta-commons-cli
BuildRequires: jakarta-commons-collections >= 0:3.1
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging
BuildRequires: jaxen
BuildRequires: plexus-cli
BuildRequires: plexus-containers-container-default
BuildRequires: plexus-i18n
BuildRequires: plexus-utils >= 0:1.4.8
BuildRequires: plexus-velocity >= 0:1.1.7
BuildRequires: saxpath
BuildRequires: velocity >= 0:1.5
BuildRequires: xalan-j2 >= 0:2.7.0

Requires: cssparser
Requires: excalibur-avalon-framework
Requires: itext >= 0:1.4
Requires: jakarta-commons-cli
Requires: jakarta-commons-collections >= 0:3.1
Requires: jakarta-commons-lang
Requires: jakarta-commons-logging
Requires: plexus-cli
Requires: plexus-containers-container-default
Requires: plexus-i18n
Requires: plexus-utils >= 0:1.4.8
Requires: plexus-velocity >= 0:1.1.7
Requires: saxpath
Requires: velocity >= 0:1.5
Requires: xalan-j2 >= 0:2.7.0

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5
BuildRequires: rhino modello-maven-plugin

%description
Doxia is a content generation framework which aims to provide its
users with powerful techniques for generating static and dynamic
content. Doxia can be used to generate static sites in addition to
being incorporated into dynamic content generation systems like blogs,
wikis and content management systems.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -c -n %{name}
gzip -dc %{SOURCE1} | tar xf -
gzip -dc %{SOURCE4} | tar xf -
cp %{SOURCE3} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

%build
export JAVA_HOME=%{_jvmdir}/java-1.5.0

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/default_poms/
mkdir -p $MAVEN_REPO_LOCAL/JPP/maven2/poms/
cp doxia-%{namedversion}/doxia-core/pom.xml .m2/repository/JPP/maven2/poms/JPP.maven-doxia-core.pom
cp doxia-%{namedversion}/doxia-modules/pom.xml .m2/repository/JPP/maven2/default_poms/JPP.maven-doxia-modules.pom
mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2_SETTINGS=$(pwd)/settings.xml
%if %{with_maven}
pushd doxia-%{namedversion}
    mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install javadoc:javadoc
popd
pushd doxia-sitetools-%{namedversion}
    mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install
# won't build the javadocs when mixing old and new doxia
export CLASSPATH=$(build-classpath \
itext \
plexus/container-default \
plexus/i18n \
plexus/utils \
plexus/velocity \
velocity \
)
CLASSPATH=$CLASSPATH:$(pwd)/doxia-decoration-model/target/doxia-decoration-model-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/doxia-doc-renderer/target/doxia-doc-renderer-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/doxia-site-renderer/target/doxia-site-renderer-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/../doxia-%{namedversion}/doxia-modules/doxia-module-itext/target/doxia-module-itext-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/../doxia-%{namedversion}/doxia-modules/doxia-module-xhtml/target/doxia-module-xhtml-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/../doxia-%{namedversion}/doxia-core/target/doxia-core-%{namedversion}.jar
CLASSPATH=$CLASSPATH:$(pwd)/../doxia-%{namedversion}/doxia-sink-api/target/doxia-sink-api-%{namedversion}.jar
    for project in \
        doxia-decoration-model \
        doxia-doc-renderer \
        doxia-site-renderer \
        ; do
             pushd $project
                    ant -Dbuild.sysclasspath=only javadoc
             popd
    done
popd
%else
mkdir lib
export MDLIB=$(pwd)/lib

export CLASSPATH=$(build-classpath \
modello/core \
modello/plugin-xml \
modello/plugin-xpp3 \
modello/plugin-xdoc \
modello/plugin-xsd \
plexus/classworlds \
plexus/containers-component-api \
plexus/containers-container-default \
plexus/utils \
)

pushd doxia-%{namedversion}
pushd doxia-modules/doxia-module-fml
java org.codehaus.modello.ModelloCli src/main/mdo/fml.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/fml.mdo xsd src/main/java 1.0.0 false
popd
pushd doxia-book
java org.codehaus.modello.ModelloCli src/main/modello/book.mdo xdoc src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/modello/book.mdo xsd src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/modello/book.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/modello/book.mdo xpp3-reader src/main/java 1.0.0 false
popd
popd
pushd doxia-sitetools-%{namedversion}
pushd doxia-decoration-model
java org.codehaus.modello.ModelloCli src/main/mdo/decoration.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/decoration.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/decoration.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/decoration.mdo xsd src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/decoration.mdo xdoc src/main/java 1.0.0 false
popd
pushd doxia-doc-renderer
java org.codehaus.modello.ModelloCli src/main/mdo/document.mdo xpp3-writer src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/document.mdo java src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/document.mdo xpp3-reader src/main/java 1.0.0 false
java org.codehaus.modello.ModelloCli src/main/mdo/document.mdo xsd src/main/java 1.0.0 false
popd
popd
unset CLASSPATH

build-jar-repository -s -p $MDLIB \
      commons-cli \
      commons-collections \
      commons-httpclient \
      commons-io \
      commons-lang \
      commons-logging \
      htmlunit \
      itext \
      jaxen \
      js \
      nekohtml \
      plexus/cli \
      plexus/i18n \
      plexus/utils \
      plexus/classworlds \
      plexus/containers-component-api \
      plexus/containers-container-default \
      plexus/velocity \
      velocity \
      xalan-j2 \
      xalan-j2-serializer \

export CLASSPATH=
CLASSPATH=$CLASSPATH:$MDLIB/../doxia-%{namedversion}/doxia-core/target/test-classes
CLASSPATH=$CLASSPATH:$MDLIB/commons-cli.jar
CLASSPATH=$CLASSPATH:$MDLIB/commons-collections.jar
CLASSPATH=$CLASSPATH:$MDLIB/commons-httpclient.jar
CLASSPATH=$CLASSPATH:$MDLIB/commons-io.jar
CLASSPATH=$CLASSPATH:$MDLIB/commons-lang.jar
CLASSPATH=$CLASSPATH:$MDLIB/commons-logging.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-docbook-simple.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-latex.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-itext.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-xhtml.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-xdoc.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-module-apt.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-core.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-sink-api.jar
CLASSPATH=$CLASSPATH:$MDLIB/doxia-decoration-model.jar
CLASSPATH=$CLASSPATH:$MDLIB/htmlunit.jar
CLASSPATH=$CLASSPATH:$MDLIB/itext.jar
CLASSPATH=$CLASSPATH:$MDLIB/jaxen.jar
CLASSPATH=$CLASSPATH:$MDLIB/js.jar
CLASSPATH=$CLASSPATH:$MDLIB/nekohtml.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_cli.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_i18n.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_utils.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_classworlds.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_containers-component-api.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_containers-container-default.jar
CLASSPATH=$CLASSPATH:$MDLIB/plexus_velocity.jar
CLASSPATH=$CLASSPATH:$MDLIB/velocity.jar
CLASSPATH=$CLASSPATH:$MDLIB/xalan-j2.jar
CLASSPATH=$CLASSPATH:$MDLIB/xalan-j2-serializer.jar
CLASSPATH=$CLASSPATH:target/classes:target/test-classes

pushd doxia-%{namedversion}
for project in \
         doxia-sink-api \
         doxia-core \
         doxia-modules/doxia-module-apt \
         doxia-modules/doxia-module-confluence \
         doxia-modules/doxia-module-docbook-simple \
         doxia-modules/doxia-module-fml \
         doxia-modules/doxia-module-itext \
         doxia-modules/doxia-module-latex \
         doxia-modules/doxia-module-rtf \
         doxia-modules/doxia-module-twiki \
         doxia-modules/doxia-module-xdoc \
         doxia-modules/doxia-module-xhtml \
         doxia-book \
         ; do
         pushd $project
                ant -Dbuild.sysclasspath=only jar javadoc
                # Copy over the jar
                for j in target/*.jar; do
                    cp $j $MDLIB/$(basename $project.jar)
                done
         popd
done
popd
pushd doxia-sitetools-%{namedversion}
for project in \
    doxia-decoration-model \
    doxia-doc-renderer \
    doxia-site-renderer \
    ; do
         pushd $project
                ant -Dbuild.sysclasspath=only jar javadoc
                # Copy over the jar
                for j in target/*.jar; do
                    cp $j $MDLIB/$(basename $project.jar)
                done
         popd
done
popd

%endif

%install
# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

pushd doxia-sitetools-%{namedversion}
for project in \
    doxia-decoration-model \
    doxia-doc-renderer \
    doxia-site-renderer \
    ; do
       jarname=$(basename $project)
       destname=$(echo $jarname | sed -e 's/doxia-//')
       install -pm 644 $project/target/$jarname-%{namedversion}.jar \
             $RPM_BUILD_ROOT%{_javadir}/%{name}/$destname-%{version}.jar
       %add_to_maven_depmap org.apache.maven.doxia $jarname %{namedversion} JPP/maven-doxia $destname
       # Install pom to groupid-artifactid
       install -pm 644 $project/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-$destname.pom
done
install -pm 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-sitetools.pom
%add_to_maven_depmap org.apache.maven.doxia doxia-sitetools %{namedversion} JPP/maven-doxia sitetools
popd
pushd doxia-1.0-alpha-10
for project in \
    doxia-sink-api \
    doxia-core \
    doxia-modules/doxia-module-apt \
    doxia-modules/doxia-module-confluence \
    doxia-modules/doxia-module-docbook-simple \
    doxia-modules/doxia-module-fml \
    doxia-modules/doxia-module-itext \
    doxia-modules/doxia-module-latex \
    doxia-modules/doxia-module-rtf \
    doxia-modules/doxia-module-twiki \
    doxia-modules/doxia-module-xdoc \
    doxia-modules/doxia-module-xhtml \
    doxia-book \
%if %{with_maven}
    doxia-maven-plugin \
%endif
    ; do
       jarname=$(basename $project)
       destname=$(echo $jarname | sed -e 's/doxia-//')
       install -pm 644 $project/target/$jarname-%{namedversion}.jar \
             $RPM_BUILD_ROOT%{_javadir}/%{name}/$destname-%{version}.jar
       %add_to_maven_depmap org.apache.maven.doxia $jarname %{namedversion} JPP/maven-doxia $destname
       # Install pom to groupid-artifactid
       install -pm 644 $project/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-$destname.pom
done

install -pm 644 doxia-modules/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-modules.pom
%add_to_maven_depmap org.apache.maven.doxia doxia-modules %{namedversion} JPP/maven-doxia modules
install -pm 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.maven-doxia-doxia.pom
%add_to_maven_depmap org.apache.maven.doxia doxia %{namedversion} JPP/maven-doxia doxia
popd

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

pushd doxia-%{namedversion}
for p in \
        doxia-sink-api \
        doxia-core \
        doxia-modules/doxia-module-apt \
        doxia-modules/doxia-module-confluence \
        doxia-modules/doxia-module-docbook-simple \
        doxia-modules/doxia-module-fml \
        doxia-modules/doxia-module-itext \
        doxia-modules/doxia-module-latex \
        doxia-modules/doxia-module-rtf \
        doxia-modules/doxia-module-twiki \
        doxia-modules/doxia-module-xdoc \
        doxia-modules/doxia-module-xhtml \
        doxia-book \
%if %{with_maven}
        doxia-maven-plugin \
%endif
        ; do
            project=$(basename $p)
            install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$project
            cp -pr $p/target/site/apidocs/* \
                    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$project
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
popd
pushd doxia-sitetools-%{namedversion}
for p in \
    doxia-decoration-model \
    doxia-doc-renderer \
    doxia-site-renderer \
    ; do
            project=$(basename $p)
            install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$project
            cp -pr $p/target/site/apidocs/* \
                    $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/$project
done
popd

%files
%{_javadir}/%{name}
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sat Mar 14 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt2_0.a10.4jpp5
- maven 2.0.7 build

* Fri Jan 30 2009 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1.1jpp
maven 2.0.7 bootstrap

